'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var Extractor = (function () {
  function Extractor(baseline, tags) {
    _classCallCheck(this, Extractor);

    this.baseline = baseline;
    this.tags = tags || [];
  }

  _createClass(Extractor, [{
    key: 'tag',
    value: function tag(_tag) {
      var tags = Array.isArray(_tag) ? _tag : [_tag];
      this.tags.push.apply(this.tags, tags);
    }
  }, {
    key: 'extract',
    value: function extract(words) {
      var _this = this;

      var result = {};

      this.tags.forEach(function (tag) {
        var matches = [];
        var currentMatch = null;

        do {
          var startIndex = currentMatch ? currentMatch.start : 0;
          currentMatch = _this.match(tag, words, startIndex);

          if (currentMatch.tag !== null && currentMatch.matches > 1) {
            matches.push(currentMatch);
          }
        } while (currentMatch.start > 0);

        var bestMatch = _lodash2['default'].max(matches, function (match) {
          return match.matches;
        });

        result[tag.label] = matches.length ? bestMatch.tag : null;
      });

      return result;
    }
  }, {
    key: 'match',
    value: function match(tag, words, startIndex) {
      var word = this.baseline[tag.start - 1];
      var index = words.indexOf(word, startIndex || 0);
      var offset = index - tag.start + 1;
      var start = index + 1;
      var matches = 0;

      while (index !== -1 && typeof words[index] !== 'undefined' && typeof this.baseline[index - offset] !== 'undefined' && words[index] === this.baseline[index - offset]) {
        matches++;
        index--;
      }

      if (matches === 0) {
        return { tag: null, start: -1, matches: matches };
      }

      var endIndex = tag.end === -1 ? words.length : start + (tag.start - tag.end);

      return { tag: words.slice(start, endIndex + 1), start: start, matches: matches };
    }
  }]);

  return Extractor;
})();

exports['default'] = Extractor;
module.exports = exports['default'];